# vim: set si sts=4 ts=8 sw=4 et:
# $Id: dotdoumiapp.py,v 1.5 2003/09/27 09:08:35 hey Exp $

### Copyright (C) 2003 Son, Kyung-uk <vvs740@chol.com>

### This program is free software; you can redistribute it and/or modify
### it under the terms of the GNU General Public License as published by
### the Free Software Foundation; either version 2 of the License, or
### (at your option) any later version.

### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.

### You should have received a copy of the GNU General Public License
### along with this program; if not, write to the Free Software
### Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# system
import sys
import os
if sys.version[0] == '2':
    import pygtk
    pygtk.require('2.0')

# gnome
import gtk
import gtk.glade
import gnome, gnome.ui
gnome.init('dotdoumi', '0.1cvs')

# bonobo
import bonobo, bonobo.ui

class DotDoumi:
    def __init__(self):
        pass

    def init(self):
        self.about = None
        self.name = None
        self.png = None
 
        xml = self.xml = gtk.glade.XML('glade2/dotdoumi.glade')
        xml.signal_autoconnect({
            'on_window_destroy': self.quit,
            'on_quit_activate': self.quit,
            'on_open_activate': self.on_open_activate,
            'on_open_clicked': self.on_open_activate,
            'on_ok_clicked': self.on_ok_clicked,
            'on_cancel_clicked': self.on_cancel_clicked,
            'on_save_clicked': self.on_save_clicked,
            'on_refresh_clicked': self.on_refresh_clicked,
            'on_new_clicked': self.on_new_clicked,
            'on_project_ok_clicked': self.on_project_ok_clicked,
            'on_project_cancel_clicked': self.on_project_cancel_clicked,
            'on_about_activate': self.on_about_activate
        })

    def add_eog(self):
        eog_container = self.eog_container = bonobo.ui.Container()
        eog = self.eog = bonobo.ui.Widget("OAFIID:GNOME_EOG_Control",
                eog_container.corba_objref())
        eog.show()

        win = self.xml.get_widget('hpaned1')
        win.add2(eog)

    def main(self):
        self.add_eog()
        gtk.mainloop()

    def quit(*args):
        gtk.main_quit()

    def on_open_activate(self, event):
        fileselector = self.fileselector = self.xml.get_widget('fileselector')
        fileselector.show()

    def on_ok_clicked(self, btn):
        widget = self.fileselector
        filename = widget.get_filename()
        widget.hide()

        if filename[-3:] == 'dot' :
            basename = (filename.split("/"))[-1]
            self.name = name = (filename.split("."))[0]

            fileobj = open(filename, 'r')
            content = fileobj.read()
            fileobj.close()

            widget = self.xml.get_widget('textview')
            buffer = widget.get_buffer()
            buffer.set_text(content)

            self.on_refresh_clicked(None)

    def on_cancel_clicked(self, btn):
        widget = self.fileselector
        widget.hide()

    def on_new_clicked(self, btn):
        widget = self.xml.get_widget('project-window')
        widget.show()

    def on_project_ok_clicked(self, btn):
        widget = self.xml.get_widget('project-entry')
        entry = widget.gtk_entry()
        directory = entry.get_text()

        widget = self.xml.get_widget('projectfile-entry')
        entry = widget.gtk_entry()
        filename = entry.get_text()

        if directory != '' and filename != '':
            widget = self.xml.get_widget('project-window')
            widget.hide()

            self.directory = directory
            self.filename = filename
        else:
            pass
            #print '둘 다 채우셔야 합니다.'

    def on_project_cancel_clicked(self, btn):
        widget = self.xml.get_widget('project-window')
        widget.hide()

    def on_save_clicked(self, btn):
        if self.name is not None:
            if self.png is not None:
                filename = self.name + ".png"
                file = open(filename, 'w')
                file.write(self.png)
                file.close()

    def on_refresh_clicked(self, btn):
        widget = self.xml.get_widget('textview')
        buffer = widget.get_buffer()
        text = buffer.get_text(buffer.get_start_iter(), buffer.get_end_iter())

        w, r = os.popen2('dot -Tpng')
        w.writelines(text)
        w.close()
        png = self.png = r.read()

        path = os.getcwd()
        path += '/tmp.png'

        file = open(path, 'w')
        file.write(png)
        file.close()

        obj = self.eog.get_objref().queryInterface("IDL:Bonobo/PersistFile:1.0")
        if obj is not None :
            obj.load(path)
            obj.unref()

        import time
        time.sleep(0.01)
        os.remove(path)

    def on_about_activate(self, event):
        self.about = about = self.xml.get_widget('about_window')
        if about is not None:
            about.show()

def main():
    app = DotDoumi()
    app.init()
    app.main()

if __name__ == '__main__':
    main()

